// =================================================================================
//	CControlSite.h				1996-97 Microsoft Corporation All rights reserved.
// =================================================================================

#ifndef _H_CControlSite
#define _H_CControlSite
#pragma once

#include "CBaseSite.h"

class CControlContainer;

class CControlSite : 
	public CXSite
{

public:
	// *** CControlSite methods ***
	CControlSite(void);
	CControlSite(CControlContainer* inContainer, Uint32 inTop, Uint32 inLeft, Uint32 inHeight, Uint32 inWidth);
	~CControlSite(void);

	virtual Boolean8 Contains (Point inWhere);
    
   // **** IContainerSite methods ***
	STDMETHOD (RequestFocus) (THIS_ Boolean inAcquire, FocusSet inFocus);
	STDMETHOD (AcquireContext) (THIS_ Uint32 inContextID, DrawContext* outContext);
	STDMETHOD (ReleaseContext) (THIS_ DrawContext* inContext);
	STDMETHOD (SetIdleTime) (Int32 WaitTicks, Uint32 IdleRefCon);

   // **** IControl methods ***
    STDMETHOD (Draw) (THIS_ DrawContext* inContext);
	STDMETHOD (OnContextChange) (THIS_ UInt32 inContextID, ContextCommand inCommand);
	STDMETHOD (DoActivate)(THIS_ ActivateEventType inActiveET, UInt32 inContextID, PlatformEvent* inEvent) ;

private:

    // *** private methods ***
	ErrorCode	EstablishContext (DrawContext* inContext, DrawContext* outContext);
	ErrorCode	RestoreContext (void);

    // *** private members ***
    CControlContainer*	mContainerP;
    Point				mLocation;
    Point				mDimensions;
    DrawContext			mContext;
};

#endif
